package com.cool.hot100.common_arr;

import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Num56 {


    /**
     * Date 2024/8/19
     * DayNumber 1
     * 以数组 intervals 表示若干个区间的集合，其中单个区间为 intervals[i] = [starti, endi] 。请你合并所有重叠的区间，并返回 一个不重叠的区间数组，该数组需恰好覆盖输入中的所有区间 。
     * 示例 1：
     * 输入：intervals = [[1,3],[2,6],[8,10],[15,18]]
     * 输出：[[1,6],[8,10],[15,18]]
     * 解释：区间 [1,3] 和 [2,6] 重叠, 将它们合并为 [1,6].
     * 示例 2：
     * 输入：intervals = [[1,4],[4,5]]
     * 输出：[[1,5]]
     * 解释：区间 [1,4] 和 [4,5] 可被视为重叠区间。
     */
    public int[][] merge(int[][] intervals) {
        Arrays.sort(intervals, (p, q) -> p[0] - q[0]); // 按照左端点从小到大排序
        List<int[]> list=new ArrayList<>();
        list.add(intervals[0]);
        for (int[] interval : intervals) {
            int index = list.size() - 1;
            if (list.get(index)[1] < interval[0]) {
                list.add(interval);
            } else {
                list.get(index)[1] = Math.max(list.get(index)[1], interval[1]);
            }

        }
        return list.toArray(new int[list.size()][]);
    }


    @Test
    public void test(){
        merge(new int[][]{{2,3},{2,2},{3,3},{1,3},{5,7},{2,2},{4,6}});
    }
}
